module controlmotor(control, rmotor, lmotor, l_direction, r_direction, CLK);
	input [2:0] control;
	input CLK;
	output [7:0]l_direction, r_direction; //8'b01111111 = backward, 8'b00111111 = forward
	output rmotor;
	output lmotor;
	
	reg rmotor, lmotor; 
	reg [7:0] l_direction, r_direction;
	
	//reg rmotor_out, lmotor_out;

always @(posedge CLK)
	begin
	case (control)
	//hard left
	0: 
		begin
			rmotor <= 1;
			lmotor <= 1;
			l_direction <= 8'b00111111;
			r_direction <= 8'b00111111;
		end
	// mild left
	1: 
		begin	
			rmotor <= 1;
			lmotor <= 1;
			l_direction <= 8'b01001000;
			r_direction <= 8'b00111111;
		end
	// drift left
	2:
		begin
			rmotor <= 1;
			lmotor <= 1;
			l_direction <= 8'b01001100;
			r_direction <= 8'b00111111;
			
		end
	// go forward
	3: 
		begin
			rmotor <= 1;
			lmotor <= 1;
			l_direction <= 8'b00111111;
			r_direction <= 8'b01111111;
		end	
	//drift right
	4:
		begin
	
			rmotor <= 1;
			lmotor <= 1;
			l_direction <= 8'b11111100;
			r_direction <= 8'b01111100;
		end	
	//turn right
	5:
		begin
			rmotor <= 1;
			lmotor <= 1;
			l_direction <= 8'b01100111;
			r_direction <= 8'b01100111;
		end	
	// hard right
	6:
		begin
			rmotor <= 1;
			lmotor <= 1;
			l_direction <= 8'b01111111;
			r_direction <= 8'b01111111;
		end	
	default: 
		begin
			rmotor <= 0;
			lmotor <= 0;
			l_direction <= 8'b00111111;
			r_direction <= 8'b00111111;
		end
	endcase
	end



endmodule 