module detectRed (	oRed,
					oGreen,
					oBlue,
					oDVAL,
					iRed,
					iGreen,
					iBlue,
					iDVAL,
					/////////////////////
					iX_Cont,
					iY_Cont,
					oXLeft,
					oXRight,
					oYTop,
					oYBot,
					oXLeftPrev,
					oXRightPrev,
					oYTopPrev,
					oYBotPrev,
					oXLeftPrev2,
					oXRightPrev2,
					oYTopPrev2,
					oYBotPrev2,
					oXLeftPrev3,
					oXRightPrev3,
					oYTopPrev3,
					oYBotPrev3,
					oRedArea,
					/////////////////////
					iCLK,
					iRST	);

	input			iDVAL;
	input			iCLK;
	input			iRST;
	input	[9:0]	iRed;
	input	[9:0]	iGreen;
	input	[9:0]	iBlue;
	
	input	[10:0]	iX_Cont;
	input	[10:0]	iY_Cont;
		
	output	[9:0]	oRed;
	output	[9:0]	oGreen;
	output	[9:0]	oBlue;
	output			oDVAL;
	
	//////////////////////////////////////
	output	[10:0]	oXLeft;
	output	[10:0]	oXRight;
	output	[10:0]	oYTop;
	output	[10:0]	oYBot;
	output	[10:0]	oXLeftPrev;
	output	[10:0]	oXRightPrev;
	output	[10:0]	oYTopPrev;
	output	[10:0]	oYBotPrev;
	output	[10:0]	oXLeftPrev2;
	output	[10:0]	oXRightPrev2;
	output	[10:0]	oYTopPrev2;
	output	[10:0]	oYBotPrev2;
	output	[10:0]	oXLeftPrev3;
	output	[10:0]	oXRightPrev3;
	output	[10:0]	oYTopPrev3;
	output	[10:0]	oYBotPrev3;
	output	[18:0]	oRedArea;
	//////////////////////////////////////
	
	reg		[9:0]	regRed;
	reg		[9:0]	regGreen;
	reg		[9:0]	regBlue;
	
	//////////////////////////////////////
	reg		[10:0]	leftX;
	reg		[10:0]	rightX;
	reg		[10:0]	topY;
	reg		[10:0]	botY;
	reg		[10:0]	newLeftX;
	reg		[10:0]	newRightX;
	reg		[10:0]	newTopY;
	reg		[10:0]	newBotY;
	
	reg		[10:0]	prevLeftX;
	reg		[10:0]	prevRightX;
	reg		[10:0]	prevTopY;
	reg		[10:0]	prevBotY;
	
	reg		[10:0]	prev2LeftX;
	reg		[10:0]	prev2RightX;
	reg		[10:0]	prev2TopY;
	reg		[10:0]	prev2BotY;
	
	reg		[10:0]	prev3LeftX;
	reg		[10:0]	prev3RightX;
	reg		[10:0]	prev3TopY;
	reg		[10:0]	prev3BotY;
	
	reg		[18:0]	redArea;
	reg		[18:0]	newRedArea;
	
	reg				frameClock;
	wire	[10:0]	avgLeftX;
	wire	[10:0]	avgRightX;
	wire	[10:0]	avgTopY;
	wire	[10:0]	avgBotY;
	//////////////////////////////////////
	
	wire	[21:0]	rgbSquaredSum;
	wire	[19:0]	rSquared;
	wire	[19:0]	gSquared;
	wire	[19:0]	bSquared;
	wire	[21:0]	distance;
	wire	[9:0]	grayValue;
			
	assign	rSquared		=	(10'hFFFF - iRed) * (10'hFFFF - iRed);
	assign	gSquared		=	(iGreen>10'b0100000000) ? ((iGreen - 10'b0100000000) * (iGreen - 10'b0100000000)) : ((10'b0100000000 - iGreen) * (10'b0100000000 - iGreen));
	assign	bSquared		=	iBlue * iBlue;

	assign	rgbSquaredSum	=	rSquared + gSquared + bSquared;
	assign	grayValue		=	(iRed >> 2) + (iBlue >> 2) + (iGreen >> 1);
	
	assign	oRed			=	regRed;
	assign	oGreen			=	regGreen;
	assign	oBlue			=	regBlue;
	assign	oDVAL			=	iDVAL;
	
	//////////////////////////////////////////////////
	assign	oXLeft			=	leftX;
	assign	oXRight			=	rightX;
	assign	oYTop			=	topY;
	assign	oYBot			=	botY;
	assign	oXLeftPrev		=	prevLeftX;
	assign	oXRightPrev		=	prevRightX;
	assign	oYTopPrev		=	prevTopY;
	assign	oYBotPrev		=	prevBotY;
	assign	oXLeftPrev2		=	prev2LeftX;
	assign	oXRightPrev2	=	prev2RightX;
	assign	oYTopPrev2		=	prev2TopY;
	assign	oYBotPrev2		=	prev2BotY;
	assign	oXLeftPrev3		=	prev3LeftX;
	assign	oXRightPrev3	=	prev3RightX;
	assign	oYTopPrev3		=	prev3TopY;
	assign	oYBotPrev3		=	prev3BotY;
	assign	oRedArea		=	redArea;
	//////////////////////////////////////////////////
	
	average	leftXAvg	(avgLeftX, leftX, 5, frameClock);
	average	rightXAvg	(avgRightX, rightX, 5, frameClock);
	average	topYAvg		(avgTopY, topY, 5, frameClock);
	average	botYAvg		(avgBotY, botY, 5, frameClock);
	
	always@(posedge iCLK or posedge iRST)
	begin
		if(iRST)
		begin
			regRed		<=	10'b0;
			regGreen	<=	10'b0;
			regBlue		<=	10'b0;
			
			leftX		<=	11'hFFFF;
			rightX		<=	11'h0;
			topY		<=	11'hFFFF;
			botY		<=	11'h0;
			
			newLeftX	<=	11'hFFFF;
			newRightX	<=	11'h0;
			newTopY		<=	11'hFFFF;
			newBotY		<=	11'h0;
			
			prevLeftX	<=	11'hFFFF;
			prevRightX	<=	11'h0;
			prevTopY	<=	11'hFFFF;
			prevBotY	<=	11'h0;
			
			prev2LeftX	<=	11'hFFFF;
			prev2RightX	<=	11'h0;
			prev2TopY	<=	11'hFFFF;
			prev2BotY	<=	11'h0;
			
			prev3LeftX	<=	11'hFFFF;
			prev3RightX	<=	11'h0;
			prev3TopY	<=	11'hFFFF;
			prev3BotY	<=	11'h0;
			
			redArea		<=	19'h0;
			newRedArea	<=	19'h0;
			
			frameClock	<=	1'b1;
		end
		else
		begin
			if ((iX_Cont > 11'd5) && (iX_Cont < 11'd635) && (iY_Cont > 11'd5) && (iY_Cont < 11'd475))
			begin
				//if case when we are seeing a valid red
				if (rgbSquaredSum < 22'd15000)//22'h04FC00)//
				begin
					regRed		<=	10'hFFFF;
					regGreen	<=	10'h0000;
					regBlue		<=	10'h0000;
					
					if (iX_Cont <= newLeftX)
					begin
						if (iX_Cont >= 10'd6)
							newLeftX	<=	iX_Cont - 10'd1;
					end
					if (iX_Cont >= newRightX)
					begin
						if (iX_Cont <= 10'd634)
							newRightX	<=	iX_Cont + 10'd1;
					end
					if (iY_Cont <= newTopY)
					begin
						if (iY_Cont >= 10'd6)
							newTopY		<=	iY_Cont - 10'd1;
					end
					if (iY_Cont >= newBotY)
					begin
						if (iY_Cont <= 10'd474)
							newBotY		<=	iY_Cont + 10'd1;
					end
				end
				//not seeing a valid red
				else
				begin
					//generic case - set to gray
					regRed		<=	grayValue;
					regGreen	<=	grayValue;
					regBlue		<=	grayValue;
					
					////////////////prev3///////////////
					if ((iY_Cont == prev3BotY) && 
						((iX_Cont >= prev3LeftX) && (iX_Cont <= prev3RightX)))
					begin
						regRed		<=	10'hFFFF;
						regGreen	<=	10'h0;
						regBlue		<=	10'hFFFF;
					end
					else if ((iY_Cont == prev3TopY) && 
						((iX_Cont >= prev3LeftX) && (iX_Cont <= prev3RightX)))
					begin
						regRed		<=	10'hFFFF;
						regGreen	<=	10'h0;
						regBlue		<=	10'hFFFF;
					end
					else if ((iX_Cont == prev3LeftX) && 
							 ((iY_Cont >= prev3TopY) && (iY_Cont <= prev3BotY)))
					begin
						regRed		<=	10'hFFFF;
						regGreen	<=	10'h0;
						regBlue		<=	10'hFFFF;
					end
					else if ((iX_Cont == prev3RightX) && 
							 ((iY_Cont >= prev3TopY) && (iY_Cont <= prev3BotY)))
					begin
						regRed		<=	10'hFFFF;
						regGreen	<=	10'h0;
						regBlue		<=	10'hFFFF;
					end
					////////////////prev2///////////////
					if ((iY_Cont == prev2BotY) && 
						((iX_Cont >= prev2LeftX) && (iX_Cont <= prev2RightX)))
					begin
						regRed		<=	10'h0;
						regGreen	<=	10'hFFFF;
						regBlue		<=	10'hFFFF;
					end
					else if ((iY_Cont == prev2TopY) && 
						((iX_Cont >= prev2LeftX) && (iX_Cont <= prev2RightX)))
					begin
						regRed		<=	10'h0;
						regGreen	<=	10'hFFFF;
						regBlue		<=	10'hFFFF;
					end
					else if ((iX_Cont == prev2LeftX) && 
							 ((iY_Cont >= prev2TopY) && (iY_Cont <= prev2BotY)))
					begin
						regRed		<=	10'h0;
						regGreen	<=	10'hFFFF;
						regBlue		<=	10'hFFFF;
					end
					else if ((iX_Cont == prev2RightX) && 
							 ((iY_Cont >= prev2TopY) && (iY_Cont <= prev2BotY)))
					begin
						regRed		<=	10'h0;
						regGreen	<=	10'hFFFF;
						regBlue		<=	10'hFFFF;
					end
					////////////////prev///////////////
					if ((iY_Cont == prevBotY) && 
						((iX_Cont >= prevLeftX) && (iX_Cont <= prev2RightX)))
					begin
						regRed		<=	10'h0;
						regGreen	<=	10'hFFFF;
						regBlue		<=	10'hFFFF;
					end
					else if ((iY_Cont == prevTopY) && 
						((iX_Cont >= prevLeftX) && (iX_Cont <= prevRightX)))
					begin
						regRed		<=	10'h0;
						regGreen	<=	10'h0;
						regBlue		<=	10'hFFFF;
					end
					else if ((iX_Cont == prevLeftX) && 
							 ((iY_Cont >= prevTopY) && (iY_Cont <= prevBotY)))
					begin
						regRed		<=	10'h0;
						regGreen	<=	10'h0;
						regBlue		<=	10'hFFFF;
					end
					else if ((iX_Cont == prevRightX) && 
							 ((iY_Cont >= prevTopY) && (iY_Cont <= prevBotY)))
					begin
						regRed		<=	10'h0;
						regGreen	<=	10'h0;
						regBlue		<=	10'hFFFF;
					end
					////////////////current///////////////
					if ((iY_Cont == botY) && 
						((iX_Cont >= leftX) && (iX_Cont <= rightX)))
					begin
						regRed		<=	10'h0;
						regGreen	<=	10'hFFFF;
						regBlue		<=	10'h0;
					end
					else if ((iY_Cont == topY) && 
						((iX_Cont >=leftX) && (iX_Cont <= rightX)))
					begin
						regRed		<=	10'h0;
						regGreen	<=	10'hFFFF;
						regBlue		<=	10'h0;
					end
					else if ((iX_Cont == leftX) && 
							 ((iY_Cont >= topY) && (iY_Cont <= botY)))
					begin
						regRed		<=	10'h0;
						regGreen	<=	10'hFFFF;
						regBlue		<=	10'h0;
					end
					else if ((iX_Cont == rightX) && 
							 ((iY_Cont >= topY) && (iY_Cont <= botY)))
					begin
						regRed		<=	10'h0;
						regGreen	<=	10'hFFFF;
						regBlue		<=	10'h0;
					end
					else if ((iY_Cont > topY) && (iY_Cont < botY) && 
							 (iX_Cont > leftX) &&  (iX_Cont < rightX))
					begin
						regRed		<=	iRed;
						regGreen	<=	iGreen;
						regBlue		<=	iBlue;
						
						newRedArea	<=	newRedArea + 1'b1;
					end
				end
			end
			//***************************************************************************\\
			//border around the image
			else
			begin
				regRed		<=	10'hFFFF;
				regGreen	<=	10'hFFFF;
				regBlue		<=	10'hFFFF;
			end
			//***************************************************************************\\
			//shift the bounding box register values and reset the current frame bound box
			if ((iX_Cont == 10'd639) && (iY_Cont == 10'd239))
				frameClock	<=	~frameClock;
			if ((iX_Cont == 10'd639) && (iY_Cont == 10'd479))
			begin
				leftX		<=	newLeftX;
				rightX		<=	newRightX;
				topY		<=	newTopY;
				botY		<=	newBotY;
				
				prevLeftX	<=	leftX;
				prevRightX	<=	rightX;
				prevTopY	<=	topY;
				prevBotY	<=	botY;
				
				prev2LeftX	<=	prevLeftX;
				prev2RightX	<=	prevRightX;
				prev2TopY	<=	prevTopY;
				prev2BotY	<=	prevBotY;
				
				prev3LeftX	<=	prev2LeftX;
				prev3RightX	<=	prev2RightX;
				prev3TopY	<=	prev2TopY;
				prev3BotY	<=	prev2BotY;
				
				newLeftX	<=	11'hFFFF;
				newRightX	<=	11'h0;
				newTopY		<=	11'hFFFF;
				newBotY		<=	11'h0;
				
				redArea		<=	newRedArea;
				newRedArea	<=	19'h0;
				
				frameClock	<=	~frameClock;
			end	//end of shifting
		end
	end

endmodule

/////////////////////////////////////////////////////
//// Time weighted average amplitude          ///////
/////////////////////////////////////////////////////
// dk_const
// 3
// 4
// 5
// 6
// 7
module average (out, in, dk_const, clk);

	output reg signed [10:0] out ;
	input wire signed [10:0] in ;
	input wire [2:0] dk_const ;
	input wire clk;
	
	wire signed  [10:0] new_out ;
	//first order lowpass of absolute value of input
	assign new_out = out - (out>>dk_const) + (in>>dk_const) ;
	always @(posedge clk)
	begin
		 out <= new_out ;
	end
endmodule
//////////////////////////////////////////////////
